object Main {
    import Queue._

    def main(args:Array[String]) {
        val q:Queue[Int] = Queue(Nil)
        println("Here is a good start queue : " + q)
        println("Empty queue created, gonna enqueue it to 5 now")
        val fullQ = q.enqueue(1).enqueue(2).enqueue(3).enqueue(4).enqueue(5)
        println("queue enqueued : " + fullQ)
        println("It is now not empty anymore. Now, we are going to dequeue it.")

        val dequeued = fullQ.dequeue._2
        println("queue dequeued : " + dequeued)
        println("We can see that the 5 was sucessfully dequeued.")

        val q2 = dequeued.enqueue(6)
        println("queue renqueued : " + q2)
        println("We have renqueued the value we juste dequeued. Good, good.")

        val head = q2.headOption
        println("We will now try to get the head : " + head)
        val dequeued2 = q2.dequeue._2
        val head2 = dequeued2.headOption
        println("It worked. Good, good. Now, we test getting the new one after dequeuing : " + head2)
        println("Now to test on empty queue : " + q.headOption)

        println("It worked, wonderful. Don't need to test isEmpty, because it was written by great teacher.")

        println("We will now test the other methods. We will start with the length method :")
        val l = dequeued2.length
        println("length : " + l)

        println("We have the good length, great. Now to test the length once enqueued again:")
        val q3 = dequeued2.enqueue(7)
        println("new queue : " + q3)
        val l2 = q3.length
        println("length : " + l2)
        println("Length decreased, good. Now test on empty queue : " + q.length)

        println("Fine. We will now test the rearOption method : " + q3.rearOption)
        val dequeued3 = q3.dequeue._2
        println("Now after the queue is dequeued : " + dequeued3.rearOption)
        println("Huh huh. Now on empty queue : " + q.rearOption)

        println("Still the same. Good. Now to test the toList, starting with the last enqueued queue : " + q3.toList)
        println("And now, with the last dequeued queue : " + dequeued3.toList)
        println("Now to test on empty queue : " + q.toList)

        println("Seems good. Now to test the map method (with a +2 lambda) on the enqueued first : " + q3.map(_ + 2))
        println("Great. Now, with the last dequeued one, same lambda : " + dequeued3.map(_ + 2))
        println("Now to test on empty queue : " + q.map(_ + 2))

        println("Finally, we will use the foldLeft to simulate a toList + reverse on the enqueued : " + q3.foldLeft(Nil:List[Int])((a, b) => b::a))
        println("Now on the dequeued one : " + dequeued3.foldLeft(Nil:List[Int])((a, b) => b::a))
        println("And now on an empty one : " + q.foldLeft(Nil:List[Int])((a, b) => b::a))

        println("Eh.. let's see what happens when we try to instantiate a Queue with two lists ?")
        val badQueue = Queue(List(3,2,1), List(4, 5, 6))
        
    }
}